<template>
  <div>
    <add-card-item
      v-if="canAdd"
      :image="'evaluations.svg'"
      :enable="true"
      @click.native="openModal({})"
    />
    <div
      class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4 gap-8 py-5 w-full"
    >
      <div v-if="bulletins.length === 0" class="italic text-lg m-5">
        <div>Pas de bulletin créé</div>
      </div>
      <div v-for="bulletin in bulletins" :key="bulletin.id">
        <mat-comp-sav-card-item
          :imageName="'evaluations.svg'"
          :matCompSav="bulletin"
          :hideUpdate="!$attrs.canAdd"
          @click.native="selectBulletin(bulletin)"
          @onUpdateClick="openModal(bulletin)"
        />
      </div>
    </div>
    <modal-add-bulletin
      :updatedBulletin="updatedBulletin"
      :value="modalOpen"
      v-if="modalOpen"
      @closeRequest="modalOpen = false"
    />
  </div>
</template>

<script>
import AddCardItem from "../AddCardItem.vue";
import MatCompSavCardItem from "../MatCompSavCardItem.vue";
import ModalAddBulletin from "../modals/ModalAddBulletin.vue";
export default {
  components: {
    MatCompSavCardItem,
    ModalAddBulletin,
    AddCardItem,
  },
  /*   created() {
    this.$store.dispatch("bindBulletins", this.classe);
    this.$store.dispatch("bindEvaluations", this.classe);
    this.$store.dispatch("bindSavoirs", this.classe);
  }, */
  data() {
    return {
      modalOpen: false,
      evaluatedBulletin: Object,
      updatedBulletin: Object,
      canAdd: this.$attrs.canAdd,
      evaluating: this.$route.name === "Evaluer",
    };
  },
  methods: {
    selectBulletin(bulletin) {
      if (this.evaluating) {
        //this.$emit("evaluateBulletin", bulletin);
        this.$router.push({ path: `bulletin/${bulletin.id}`, append: true });
      } else
        this.$router.push({ path: `bulletin/${bulletin.id}`, append: true });
    },
    openModal(updatedBulletin) {
      this.updatedBulletin = updatedBulletin;
      this.modalOpen = true;
    },
  },
  computed: {
    bulletins() {
      return this.$store.state.bulletins;
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
  },
};
</script>

<style>
</style>